ConRO.Mage = {};
ConRO.Mage.CheckTalents = function()
end
ConRO.Mage.CheckPvPTalents = function()
end
local ConRO_Mage, ids = ...;

function ConRO:EnableRotationModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Mage.CheckTalents;
	self.ModuleOnEnable = ConRO.Mage.CheckPvPTalents;
	if mode == 1 then
		self.Description = "Mage [Arcane - Caster]";
		self.NextSpell = ConRO.Mage.Arcane;
		self.ToggleDamage();
	end;
	if mode == 2 then
		self.Description = "Mage [Fire - Caster]";
		self.NextSpell = ConRO.Mage.Fire;
		self.ToggleDamage();
	end;
	if mode == 3 then
		self.Description = "Mage [Frost - Caster]";
		self.NextSpell = ConRO.Mage.Frost;
		self.ToggleDamage();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Mage.CheckTalents;
	self.ModuleOnEnable = ConRO.Mage.CheckPvPTalents;
	if mode == 1 then
		self.NextDef = ConRO.Mage.ArcaneDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.Mage.FireDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.Mage.FrostDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

function ConRO.Mage.Arcane(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Resources	
	local mana												= UnitPower('player', Enum.PowerType.Mana);
	local manaMax 											= UnitPowerMax('player', Enum.PowerType.Mana);
	local manapercent 										= math.max(0, mana) / math.max(1, manaMax) * 100;
	local arcCharges 										= UnitPower('player', Enum.PowerType.ArcaneCharges);

--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilties	
	local counter 											= ConRO:AbilityReady(ids.Arc_Ability.Counterspell, timeShift);
	local ssteal 											= ConRO:AbilityReady(ids.Arc_Ability.Spellsteal, timeShift);
	local aexp												= ConRO:AbilityReady(ids.Arc_Ability.ArcaneExplosion, timeShift);
	local amissiles 										= ConRO:AbilityReady(ids.Arc_Ability.ArcaneMissiles, timeShift);
		local ccBuff 											= ConRO:Aura(ids.Arc_Buff.Clearcasting, timeShift);	
		local ccPvPBuff 										= ConRO:Aura(ids.Arc_Buff.ClearcastingPvP, timeShift);	
	local apower, apCD 										= ConRO:AbilityReady(ids.Arc_Ability.ArcanePower, timeShift);
		local apBuff, _, apDUR									= ConRO:Aura(ids.Arc_Buff.ArcanePower, timeShift);
	local abarrage 											= ConRO:AbilityReady(ids.Arc_Ability.ArcaneBarrage, timeShift);
	local pom 												= ConRO:AbilityReady(ids.Arc_Ability.PresenceofMind, timeShift);
		local pomBuff 											= ConRO:Form(ids.Arc_Form.PresenceofMind, timeShift);
	local evo, evoCD										= ConRO:AbilityReady(ids.Arc_Ability.Evocation, timeShift);
		local evoBuff 											= ConRO:Aura(ids.Arc_Buff.Evocation, timeShift);	
	local ablast	 										= ConRO:AbilityReady(ids.Arc_Ability.ArcaneBlast, timeShift);
		local rotBuff 											= ConRO:Aura(ids.Arc_Buff.RuleofThrees, timeShift);
	local aint												= ConRO:AbilityReady(ids.Arc_Ability.ArcaneIntellect, timeShift);
	local totMagiRDY										= ConRO:AbilityReady(ids.Arc_Ability.TouchoftheMagi, timeShift);
		local totmDebuff 										= ConRO:TargetAura(ids.Arc_Debuff.TouchoftheMagi, timeShift);
	local cManaGemRDY										= ConRO:AbilityReady(ids.Arc_Ability.ConjureManaGem, timeShift);
		local mGemCD											= ConRO:ItemCooldown(ids.Arc_Ability.ManaGem, timeShift);
		local mGemCount											= GetItemCount(ids.Arc_Ability.ManaGem, false, true);
		
	local rpower				  							= ConRO:AbilityReady(ids.Arc_Talent.RuneofPower, timeShift);
		local runeCharges										= ConRO:SpellCharges(ids.Arc_Talent.RuneofPower);
		local rpBuff 											= ConRO:Form(ids.Arc_Form.RuneofPower, timeShift);
	local afam												= ConRO:AbilityReady(ids.Arc_Talent.ArcaneFamiliar, timeShift);
		local afBuff 											= ConRO:Aura(ids.Arc_Buff.ArcaneFamiliar, timeShift);
	local aorb 												= ConRO:AbilityReady(ids.Arc_Talent.ArcaneOrb, timeShift);
	local ntemp 											= ConRO:AbilityReady(ids.Arc_Talent.NetherTempest, timeShift);
		local ntDebuff 											= ConRO:TargetAura(ids.Arc_Debuff.NetherTempest, timeShift + 3);
	local snova 											= ConRO:AbilityReady(ids.Arc_Talent.Supernova, timeShift);

	local _Deathborne_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Deathborne, timeShift);
	local _MirrorsofTorment_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.MirrorsofTorment, timeShift);
		local _MirrorsofTorment_DEBUFF							= ConRO:TargetAura(ids.Covenant_Debuff.MirrorsofTorment, timeShift);		
	local _RadiantSpark_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.RadiantSpark, timeShift);
	local _ShiftingPower_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.ShiftingPower, timeShift);
	
--Conditions
	local incombat 											= UnitAffectingCombat('player');
	local Close 											= CheckInteractDistance("target", 3);
	local targetPh 											= ConRO:PercentHealth('target');
	local ispvp												= UnitIsPVP('player');
	
	if currentSpell == ids.Arc_Ability.ArcaneBlast then
		arcCharges = arcCharges + 1;
	end
	if currentSpell == ids.Arc_Ability.TouchoftheMagi then
		arcCharges = 4;
	end
	
	local manaThreshold = 60;
		if tChosen[ids.Arc_Talent.Enlightened] then
			manaThreshold = 80;
		end
	
	if ispvp then
		if pvpChosen[ids.Arc_PvPTalent.ArcaneEmpowerment] then
			ccBuff = ccPvPBuff;
		end
	end

--Indicators	
	ConRO:AbilityInterrupt(ids.Arc_Ability.Counterspell, counter and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Arc_Ability.Spellsteal, ssteal and ConRO:Purgable());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	
	ConRO:AbilityRaidBuffs(ids.Arc_Ability.ArcaneIntellect, aint and not ConRO:RaidBuff(ids.Arc_Ability.ArcaneIntellect));
	
	ConRO:AbilityBurst(ids.Arc_Ability.ArcanePower, apower and (evo or evoCD < 15) and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.Deathborne, incombat and _Deathborne_RDY and ConRO_BurstButton:IsVisible());
	
--Warnings	
	
--Rotations
	if evoBuff and mana < manaMax then
		return ids.Arc_Ability.Evocation;
	end

	if not incombat then
		if cManaGemRDY and mGemCount <= 0 then
			return ids.Arc_Ability.ConjureManaGem;
		end

		if ablast and currentSpell ~= ids.Arc_Ability.ArcaneBlast and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.ArcaneBlast;
		end

		if abarrage and totMagiRDY and arcCharges >= 4 and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.ArcaneBarrage;
		end
		
		if totMagiRDY and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.TouchoftheMagi;
		end
		
	end
	
	if apBuff or (not apower and apCD >= 30 and (evo or evoCD < 30)) then
		if _RadiantSpark_RDY and currentSpell ~= ids.Covenant_Ability.RadiantSpark then
			return ids.Covenant_Ability.RadiantSpark;
		end

		if _Deathborne_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.Deathborne;
		end		

		if _MirrorsofTorment_RDY and currentSpell ~= ids.Covenant_Ability.MirrorsofTorment then
			return ids.Covenant_Ability.MirrorsofTorment;
		end

		if aorb and not totMagiRDY and arcCharges <= 3 and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Talent.ArcaneOrb;
		end

		if ntemp and arcCharges >= 4 and not ntDebuff and not apBuff and not rpBuff then
			return ids.Arc_Talent.NetherTempest;
		end

		if mGemCD <= 0 and mGemCount > 0 and manapercent <= 85 and not apBuff then
			return ids.Arc_Ability.ManaGem;
		end

		if rpower and not rpBuff and not apBuff and currentSpell ~= ids.Arc_Talent.RuneofPower then
			return ids.Arc_Talent.RuneofPower;
		end
		
		if totMagiRDY and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.TouchoftheMagi;
		end
		
		if pom and not pomBuff and apBuff and apDUR <= 3 then
			return ids.Arc_Ability.PresenceofMind;
		end
			
		if ConRO_AoEButton:IsVisible() then
			if abarrage and arcCharges >= 4 then
				return ids.Arc_Ability.ArcaneBarrage;
			end
			
			if aexp then
				return ids.Arc_Ability.ArcaneExplosion;
			end			
		else
			if amissiles and (ccBuff or (totmDebuff and tChosen[ids.Arc_Talent.ArcaneEcho])) and manapercent < 95 then
				return ids.Arc_Ability.ArcaneMissiles;
			end	
		
			if ablast then
				return ids.Arc_Ability.ArcaneBlast;
			end
		end
		
		if evo then
			return ids.Arc_Ability.Evocation;
		end	
		
	elseif apower and (evo or evoCD < 30) and ConRO_FullButton:IsVisible() then 
		if abarrage and totMagiRDY and arcCharges >= 4 and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.ArcaneBarrage;
		end

		if apower and totmDebuff or currentSpell == ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.ArcanePower;
		end	
		
		if _RadiantSpark_RDY and currentSpell ~= ids.Covenant_Ability.RadiantSpark then
			return ids.Covenant_Ability.RadiantSpark;
		end
		
		if _Deathborne_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.Deathborne;
		end		

		if _MirrorsofTorment_RDY and currentSpell ~= ids.Covenant_Ability.MirrorsofTorment then
			return ids.Covenant_Ability.MirrorsofTorment;
		end
		
		if totMagiRDY and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.TouchoftheMagi;
		end

		if aorb and not totMagiRDY and arcCharges <= 3 and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Talent.ArcaneOrb;
		end

		if ntemp and arcCharges >= 4 and not ntDebuff then
			return ids.Arc_Talent.NetherTempest;
		end
		
		if ablast and arcCharges < 4 and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.ArcaneBlast;
		end
		
	elseif totmDebuff then
		if amissiles and tChosen[ids.Arc_Talent.ArcaneEcho] then
			return ids.Arc_Ability.ArcaneMissiles;
		end
		
		if ablast then
			return ids.Arc_Ability.ArcaneBlast;
		end	
	else
		if _ShiftingPower_RDY and Close and not apower and not evo and not totMagiRDY then
			return ids.Covenant_Ability.ShiftingPower;
		end

		if rpower and not rpBuff and totMagiRDY and apCD >= 42 and currentSpell ~= ids.Arc_Talent.RuneofPower then
			return ids.Arc_Talent.RuneofPower;
		end

		if abarrage and arcCharges >= 1 and totMagiRDY and apCD >= 40 and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.ArcaneBarrage;
		end
			
		if totMagiRDY and apCD >= 40 and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Ability.TouchoftheMagi;
		end
		
		if _RadiantSpark_RDY and currentSpell ~= ids.Covenant_Ability.RadiantSpark then
			return ids.Covenant_Ability.RadiantSpark;
		end

		if ntemp and arcCharges >= 4 and not ntDebuff then
			return ids.Arc_Talent.NetherTempest;
		end	

		if aorb and not totMagiRDY and arcCharges <= 3 and currentSpell ~= ids.Arc_Ability.TouchoftheMagi then
			return ids.Arc_Talent.ArcaneOrb;
		end

		if ablast and rotBuff then
			return ids.Arc_Ability.ArcaneBlast;
		end

		if snova then
			return ids.Arc_Talent.Supernova;
		end
		
		if ConRO_AoEButton:IsVisible() then
			if aexp and ccBuff then
				return ids.Arc_Ability.ArcaneExplosion;
			end
			
			if abarrage and arcCharges >= 4 and (manapercent < manaThreshold) then
				return ids.Arc_Ability.ArcaneBarrage;
			end

			if aexp then
				return ids.Arc_Ability.ArcaneExplosion;
			end
		else
			if amissiles and ccBuff and manapercent < 95 then
				return ids.Arc_Ability.ArcaneMissiles;
			end

			if abarrage and arcCharges >= 2 and manapercent < manaThreshold then
				return ids.Arc_Ability.ArcaneBarrage;
			end
		end

		if ablast then
			return ids.Arc_Ability.ArcaneBlast;
		end
	end
return nil;		
end

function ConRO.Mage.ArcaneDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Abilties
	local pbarrier 											= ConRO:AbilityReady(ids.Arc_Ability.PrismaticBarrier, timeShift);
		local pbBuff 											= ConRO:Aura(ids.Arc_Buff.PrismaticBarrier, timeShift);
	local iblock 											= ConRO:AbilityReady(ids.Arc_Ability.IceBlock, timeShift);
	local mimage 											= ConRO:AbilityReady(ids.Arc_Ability.MirrorImage, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');
	local incombat 											= UnitAffectingCombat('player');
	
--Rotations	
	if iblock and playerPh <= 25 and incombat then
		return ids.Arc_Ability.IceBlock;
	end

	if pbarrier and not pbBuff then
		return ids.Arc_Ability.PrismaticBarrier;
	end
	
	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end	
	
	if mimage and incombat then
		return ids.Arc_Ability.MirrorImage;
	end
	
	return nil;
end

function ConRO.Mage.Fire(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Resources
	local mana 												= UnitPower('player', Enum.PowerType.Mana);
	local manaMax 											= UnitPowerMax('player', Enum.PowerType.Mana);
	local manapercent 										= math.max(0, mana) / math.max(1, manaMax) * 100;
	
--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities
	local counter 											= ConRO:AbilityReady(ids.Fire_Ability.Counterspell, timeShift);
	local ssteal 											= ConRO:AbilityReady(ids.Fire_Ability.Spellsteal, timeShift);
	local fball 											= ConRO:AbilityReady(ids.Fire_Ability.Fireball, timeShift);
		local hupBuff											= ConRO:Aura(ids.Fire_Buff.HeatingUp, timeShift);
		local hsBuff 											= ConRO:Aura(ids.Fire_Buff.HotStreak, timeShift);
		local pyroBuff, pBCount									= ConRO:Aura(ids.Fire_Buff.Pyroclasm, timeShift);
	local pblast, _, pbMCD, pbCAST							= ConRO:AbilityReady(ids.Fire_Ability.Pyroblast, timeShift);		
	local fblast											= ConRO:AbilityReady(ids.Fire_Ability.FireBlast, timeShift);
		local blastCharges 										= ConRO:SpellCharges(ids.Fire_Ability.FireBlast);
	local scorch 											= ConRO:AbilityReady(ids.Fire_Ability.Scorch, timeShift);
	local dbreath 											= ConRO:AbilityReady(ids.Fire_Ability.DragonsBreath, timeShift);
	local fstrike 											= ConRO:AbilityReady(ids.Fire_Ability.Flamestrike, timeShift);
	local combust, cbCD										= ConRO:AbilityReady(ids.Fire_Ability.Combustion, timeShift);
		local comBuff, _, comDUR								= ConRO:Aura(ids.Fire_Buff.Combustion, timeShift);
	local aint												= ConRO:AbilityReady(ids.Fire_Ability.ArcaneIntellect, timeShift);
	local pflames											= ConRO:AbilityReady(ids.Fire_Ability.PhoenixFlames, timeShift);
		local flamesCharges, _, pfCCD							= ConRO:SpellCharges(ids.Fire_Ability.PhoenixFlames);
	
	local meteor 											= ConRO:AbilityReady(ids.Fire_Talent.Meteor, timeShift);
	local rpower											= ConRO:AbilityReady(ids.Fire_Talent.RuneofPower, timeShift);
		local runeCharges, _, rpCCD								= ConRO:SpellCharges(ids.Fire_Talent.RuneofPower);
		local rpBuff 											= ConRO:Form(ids.Fire_Form.RuneofPower);
	local lbomb 											= ConRO:AbilityReady(ids.Fire_Talent.LivingBomb, timeShift);

	local _Deathborne_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Deathborne, timeShift);
	local _MirrorsofTorment_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.MirrorsofTorment, timeShift);
		local _MirrorsofTorment_DEBUFF							= ConRO:TargetAura(ids.Covenant_Debuff.MirrorsofTorment, timeShift);		
	local _RadiantSpark_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.RadiantSpark, timeShift);
	local _ShiftingPower_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.ShiftingPower, timeShift);
	
--Conditions
	local incombat 											= UnitAffectingCombat('player');
	local moving 											= ConRO:PlayerSpeed();
	local targetPh 											= ConRO:PercentHealth('target');
	local Close 											= CheckInteractDistance("target", 3);
	
	local scorchball = false;
	
	if moving then
		scorchball = ids.Fire_Ability.Scorch;
	else
		scorchball = ids.Fire_Ability.Fireball;
	end
	
	if currentSpell == ids.Fire_Ability.Pyroblast then
		pBCount = pBCount - 1;
	end

--Indicators	
	ConRO:AbilityInterrupt(ids.Fire_Ability.Counterspell, counter and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Fire_Ability.Spellsteal, ssteal and ConRO:Purgable());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	
	ConRO:AbilityRaidBuffs(ids.Fire_Ability.ArcaneIntellect, aint and not ConRO:RaidBuff(ids.Fire_Ability.ArcaneIntellect));

	ConRO:AbilityBurst(ids.Fire_Ability.Combustion, combust and hsBuff and (currentSpell == ids.Fire_Ability.Fireball or currentSpell == ids.Fire_Ability.Scorch) and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.Deathborne, incombat and _Deathborne_RDY and ConRO_BurstButton:IsVisible());
	
--Warnings	
	
--Rotations	
	if not incombat then
		if pblast and currentSpell ~= ids.Fire_Ability.Pyroblast then
			return ids.Fire_Ability.Pyroblast;
		end

		if combust and currentSpell == ids.Fire_Ability.Pyroblast and not tChosen[ids.Fire_Talent.Firestarter] and ConRO_FullButton:IsVisible() then
			return ids.Fire_Ability.Combustion;
		end
		
		if fball then
			return ids.Fire_Ability.Fireball;
		end		
	elseif tChosen[ids.Fire_Talent.Firestarter] and targetPh >= 90 then
		if pblast and pyroBuff and pBCount >= 1 then
			return ids.Fire_Ability.Pyroblast;
		end

		if fblast and not hupBuff and not hsBuff then
			return ids.Fire_Ability.FireBlast;
		end	
		
		if pblast and ((hupBuff and currentSpell ~= ids.Fire_Ability.Pyroblast) or (hsBuff and currentSpell == ids.Fire_Ability.Fireball)) then
			return ids.Fire_Ability.Pyroblast;
		end

		if fball and hsBuff and currentSpell ~= ids.Fire_Ability.Fireball then
			return ids.Fire_Ability.Fireball;
		end
		
		if fball and currentSpell ~= ids.Fire_Ability.Fireball then
			return ids.Fire_Ability.Fireball;
		end
	elseif comBuff then
		if pblast and hsBuff or (hupBuff and (currentSpell == ids.Fire_Ability.Scorch or currentSpell == ids.Fire_Ability.Pyroblast)) then
			return ids.Fire_Ability.Pyroblast;
		end

		if meteor then
			return ids.Fire_Talent.Meteor;
		end

		if dbreath and not pflames and not fblast and ((hupBuff and tChosen[ids.Fire_Talent.AlexstraszasFury]) or ConRO.lastSpellId == ids.Fire_Ability.Pyroblast) then
			return ids.Fire_Ability.DragonsBreath;
		end
		
		if pflames and (not fblast or flamesCharges >= 3) and (hupBuff or ConRO.lastSpellId == ids.Fire_Ability.Pyroblast) then
			return ids.Fire_Ability.PhoenixFlames;
		end
		
		if fblast and (hupBuff or ConRO.lastSpellId == ids.Fire_Ability.Pyroblast) then
			return ids.Fire_Ability.FireBlast;
		end

		if pblast and pyroBuff and pBCount >= 1 and comDUR < pbCAST + 0.5 then
			return ids.Fire_Ability.Pyroblast;
		end
		
		if scorch then
			return ids.Fire_Ability.Scorch;
		end	
	else
		if fblast and hupBuff and (combust or ((blastCharges >= 1 and cbCD >= 20) or (blastCharges >= 2 and cbCD >= 10) or blastCharges >= 3)) and (currentSpell == ids.Fire_Ability.Fireball or currentSpell == ids.Fire_Ability.Scorch or currentSpell == ids.Fire_Ability.Pyroblast or currentSpell == ids.Fire_Ability.Flamestrike) then
			return ids.Fire_Ability.FireBlast;
		end

		if combust and hsBuff and (currentSpell == ids.Fire_Ability.Fireball or currentSpell == ids.Fire_Ability.Scorch or currentSpell == ids.Fire_Ability.Pyroblast or currentSpell == ids.Fire_Ability.Flamestrike) and ConRO_FullButton:IsVisible() then
			return ids.Fire_Ability.Combustion;
		end

		if fstrike and hsBuff and (currentSpell == ids.Fire_Ability.Fireball or currentSpell == ids.Fire_Ability.Scorch or currentSpell == ids.Fire_Ability.Flamestrike) and ConRO_AoEButton:IsVisible() then
			return ids.Fire_Ability.Flamestrike;
		end

		if pblast and hsBuff and (currentSpell == ids.Fire_Ability.Fireball or currentSpell == ids.Fire_Ability.Scorch or currentSpell == ids.Fire_Ability.Pyroblast) then
			return ids.Fire_Ability.Pyroblast;
		end
		
		if _Deathborne_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.Deathborne;
		end

		if _ShiftingPower_RDY and Close and not combust then
			return ids.Covenant_Ability.ShiftingPower;
		end
		
		if _RadiantSpark_RDY and currentSpell ~= ids.Covenant_Ability.RadiantSpark then
			return ids.Covenant_Ability.RadiantSpark;
		end

		if _MirrorsofTorment_RDY and currentSpell ~= ids.Covenant_Ability.MirrorsofTorment then
			return ids.Covenant_Ability.MirrorsofTorment;
		end
	
		if rpower and not combust and not rpBuff and (runeCharges >= 2 or (runeCharges ==1 and rpCCD <= 2) or pyroBuff or meteor) and (cbCD > 40 or not incombat) and currentSpell ~= ids.Fire_Talent.RuneofPower then
			return ids.Fire_Talent.RuneofPower;
		end

		if meteor and (not tChosen[ids.Fire_Talent.RuneofPower] or (tChosen[ids.Fire_Talent.RuneofPower] and (rpBuff or currentSpell == ids.Fire_Talent.RuneofPower)) or cbCD > 40) and not combust then
			return ids.Fire_Talent.Meteor;
		end
	
		if hsBuff then
			if scorch and (moving or (tChosen[ids.Fire_Talent.SearingTouch] and targetPh <= 30)) and currentSpell ~= ids.Fire_Ability.Scorch and currentSpell ~= ids.Fire_Ability.Fireball then
				return ids.Fire_Ability.Scorch;
			elseif fball and currentSpell ~= ids.Fire_Ability.Fireball and currentSpell ~= ids.Fire_Ability.Scorch then
				return ids.Fire_Ability.Fireball;
			end		
		end
		
		if pblast and pyroBuff and pBCount >= 1 and not combust then
			return ids.Fire_Ability.Pyroblast;
		end

		if pflames and not hupBuff and ((flamesCharges >= 1 and cbCD >= 50) or (flamesCharges >= 2 and cbCD >= 25) or flamesCharges >= 3) then
			return ids.Fire_Ability.PhoenixFlames;
		end
		
		if dbreath and (hupBuff and tChosen[ids.Fire_Talent.AlexstraszasFury]) then
			return ids.Fire_Ability.DragonsBreath;
		end

		if lbomb and ConRO_AoEButton:IsVisible() then
			return ids.Fire_Talent.LivingBomb;
		end
		
		if scorch and (moving or (tChosen[ids.Fire_Talent.SearingTouch] and targetPh <= 30)) then
			return ids.Fire_Ability.Scorch;
		end
		
		if fball then
			return ids.Fire_Ability.Fireball;
		end
	end
end

function ConRO.Mage.FireDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Abilities	
	local blazeb 											= ConRO:AbilityReady(ids.Fire_Ability.BlazingBarrier, timeShift);
	local iblock 											= ConRO:AbilityReady(ids.Fire_Ability.IceBlock, timeShift);
	local mimage 											= ConRO:AbilityReady(ids.Fire_Ability.MirrorImage, timeShift);
	
	local bbBuff 											= ConRO:Aura(ids.Fire_Buff.BlazingBarrier, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');
	local incombat 											= UnitAffectingCombat('player');

--Rotations	
	if iblock and playerPh <= 25 and incombat then
		return ids.Fire_Ability.IceBlock;
	end

	if blazeb and not bbBuff then
		return ids.Fire_Ability.BlazingBarrier;
	end
	
	if pbarrier and not pbBuff then
		return ids.Arc_Ability.PrismaticBarrier;
	end
	
	if mimage and incombat then
		return ids.Fire_Ability.MirrorImage;
	end
	
	return nil;
end

function ConRO.Mage.Frost(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
	local plvl 												= UnitLevel("player");

--Resources
	local mana 												= UnitPower('player', Enum.PowerType.Mana);
	local manaMax 											= UnitPowerMax('player', Enum.PowerType.Mana);
	local manapercent 										= math.max(0, mana) / math.max(1, manaMax) * 100;
	
--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities
	local aExpRDY											= ConRO:AbilityReady(ids.Frost_Ability.ArcaneExplosion, timeShift);
	local cspell 											= ConRO:AbilityReady(ids.Frost_Ability.Counterspell, timeShift);
	local ssteal 											= ConRO:AbilityReady(ids.Frost_Ability.Spellsteal, timeShift);
	local iveins, ivCD										= ConRO:AbilityReady(ids.Frost_Ability.IcyVeins, timeShift);
		local ivBuff 											= ConRO:Aura(ids.Frost_Buff.IcyVeins, timeShift);
	local forb 												= ConRO:AbilityReady(ids.Frost_Ability.FrozenOrb, timeShift);
	local flurry 											= ConRO:AbilityReady(ids.Frost_Ability.Flurry, timeShift);
		local bfBuff 											= ConRO:Aura(ids.Frost_Buff.BrainFreeze, timeShift);	
		local wcDebuff, wcCount									= ConRO:TargetAura(ids.Frost_Debuff.WintersChill, timeShift);
	local fbolt 											= ConRO:AbilityReady(ids.Frost_Ability.Frostbolt, timeShift);
	local sumwele 											= ConRO:AbilityReady(ids.Frost_Ability.SummonWaterElemental, timeShift);
	local ilance											= ConRO:AbilityReady(ids.Frost_Ability.IceLance, timeShift);
		local _, icicleCount									= ConRO:Aura(ids.Frost_Buff.Icicles, timeShift);
		local fofBuff, fofCount 								= ConRO:Aura(ids.Frost_Buff.FingersofFrost, timeShift);
	local blizzard											= ConRO:AbilityReady(ids.Frost_Ability.Blizzard, timeShift);
		local frBuff											= ConRO:Aura(ids.Frost_Buff.FreezingRain, timeShift);
	local cofc												= ConRO:AbilityReady(ids.Frost_Ability.ConeofCold, timeShift);
	local aint												= ConRO:AbilityReady(ids.Frost_Ability.ArcaneIntellect, timeShift);
	
	local ebolt 											= ConRO:AbilityReady(ids.Frost_Talent.Ebonbolt, timeShift);
	local rpower				 							= ConRO:AbilityReady(ids.Frost_Talent.RuneofPower, timeShift);
		local runeCharges, _, _RuneofPower_CCD					= ConRO:SpellCharges(ids.Frost_Talent.RuneofPower);
		local rpBuff 											= ConRO:Form(ids.Frost_Form.RuneofPower, timeShift);
	local rfrost 											= ConRO:AbilityReady(ids.Frost_Talent.RayofFrost, timeShift);
	local gspike 											= ConRO:AbilityReady(ids.Frost_Talent.GlacialSpike, timeShift);
		local gspikeBuff										= ConRO:Aura(ids.Frost_Buff.GlacialSpike, timeShift);
	local inova 											= ConRO:AbilityReady(ids.Frost_Talent.IceNova, timeShift);
	local ifloes											= ConRO:AbilityReady(ids.Frost_Talent.IceFloes, timeShift);
	local cstorm 											= ConRO:AbilityReady(ids.Frost_Talent.CometStorm, timeShift);

	local iceform 											= ConRO:AbilityReady(ids.Frost_PvPTalent.IceForm, timeShift);

	local _Deathborne_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Deathborne, timeShift);
	local _MirrorsofTorment_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.MirrorsofTorment, timeShift);
		local _MirrorsofTorment_DEBUFF							= ConRO:TargetAura(ids.Covenant_Debuff.MirrorsofTorment, timeShift);		
	local _RadiantSpark_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.RadiantSpark, timeShift);
	local _ShiftingPower_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.ShiftingPower, timeShift);
	
--Conditions	
	local incombat 											= UnitAffectingCombat('player');
	local summoned 											= ConRO:CallPet();
	local assist		 									= ConRO:PetAssist();
	local ispvp												= UnitIsPVP('player');
	local Close 											= CheckInteractDistance("target", 3);
	
	if currentSpell == ids.Frost_Ability.Frostbolt then
		icicleCount = icicleCount + 1;
	elseif currentSpell == ids.Frost_Talent.GlacialSpike then
		icicleCount = 0;
	end

	local ivUSE = ids.Frost_Ability.IcyVeins;
	local foUSE = ids.Frost_Ability.FrozenOrb;
	
	if ispvp then
		if pvpChosen[ids.Frost_PvPTalent.IceForm] then
			iveins = iceform;
			ivUSE = ids.Frost_PvPTalent.IceForm;
		end
		if pvpChosen[ids.Frost_PvPTalent.ConcentratedCoolness] then
			foUSE = ids.Frost_PvPTalent.FrozenOrb;
		end		
	end
	
--Indicators	
	ConRO:AbilityInterrupt(ids.Frost_Ability.Counterspell, cspell and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Frost_Ability.Spellsteal, ssteal and ConRO:Purgable());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	
	ConRO:AbilityRaidBuffs(ids.Frost_Ability.ArcaneIntellect, aint and not ConRO:RaidBuff(ids.Frost_Ability.ArcaneIntellect));

	ConRO:AbilityBurst(ids.Frost_Ability.IcyVeins, incombat and iveins and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.Deathborne, incombat and _Deathborne_RDY and ConRO_BurstButton:IsVisible());
	
--Warnings	
	if not tChosen[ids.Frost_Talent.LonelyWinter] and not summoned and sumwele then
		UIErrorsFrame:AddMessage("Call your Water Elemental!!!", 1.0, 0.0, 0.0, 53, 5);
	end
	
	if not assist and summoned then
		UIErrorsFrame:AddMessage("Pet is NOT attacking!!!", 1.0, 0.0, 0.0, 53, 5);
	end

--Rotations	
	if not incombat then
		if _Deathborne_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.Deathborne;
		end
		
		if iveins and ConRO_FullButton:IsVisible() then
			return ivUSE;
		end
		
		if ebolt and currentSpell ~= ids.Frost_Talent.Ebonbolt then
			return ids.Frost_Talent.Ebonbolt;
		end
	
		if fbolt and currentSpell ~= ids.Frost_Ability.Frostbolt and (not tChosen[ids.Frost_Talent.Ebonbolt] or (tChosen[ids.Frost_Talent.Ebonbolt] and not ebolt))	then
			return ids.Frost_Ability.Frostbolt;
		end
		
		if forb then
			return foUSE;
		end
	elseif ConRO_AoEButton:IsVisible() then
		if _Deathborne_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.Deathborne;
		end		

		if iveins and ConRO_FullButton:IsVisible() then
			return ivUSE;
		end	

		if rpower and not rpBuff and ivCD >= 15 and currentSpell ~= ids.Frost_Talent.RuneofPower then
			return ids.Frost_Talent.RuneofPower;
		end	

		if forb then
			return foUSE;
		end

		if blizzard and currentSpell ~= ids.Frost_Ability.Blizzard then
			return ids.Frost_Ability.Blizzard;
		end

		if flurry and bfBuff and wcCount <= 0 and (currentSpell == ids.Frost_Ability.Frostbolt or currentSpell == ids.Frost_Talent.Ebonbolt or _MirrorsofTorment_DEBUFF) then
			return ids.Frost_Ability.Flurry;
		end

		if inova then
			return ids.Frost_Talent.IceNova;
		end
		
		if cstorm then
			return ids.Frost_Talent.CometStorm;
		end

		if ilance and (ConRO.lastSpellId == ids.Frost_Ability.Flurry or wcCount >= 1) then
			return ids.Frost_Ability.IceLance;
		end

		if _RadiantSpark_RDY and bfBuff and currentSpell ~= ids.Covenant_Ability.RadiantSpark then
			return ids.Covenant_Ability.RadiantSpark;
		end

		if _ShiftingPower_RDY and Close and (not tChosen[ids.Frost_Talent.RuneofPower] or (tChosen[ids.Frost_Talent.RuneofPower] and _RuneofPower_CCD >= 16) or ConRO_AoEButton:IsVisible()) then
			return ids.Covenant_Ability.ShiftingPower;
		end
		
		if _MirrorsofTorment_RDY and currentSpell ~= ids.Covenant_Ability.MirrorsofTorment then
			return ids.Covenant_Ability.MirrorsofTorment;
		end	

		if aExpRDY and manapercent >= 30 and ConRO_AoEButton:IsVisible() then
			return ids.Frost_Ability.ArcaneExplosion;
		end
		
		if ebolt and currentSpell ~= ids.Frost_Talent.Ebonbolt then
			return ids.Frost_Talent.Ebonbolt;
		end
		
		if fbolt then
			return ids.Frost_Ability.Frostbolt;
		end
	else
		if _Deathborne_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.Deathborne;
		end

		if rpower and not rpBuff and ivCD >= 15 and currentSpell ~= ids.Frost_Talent.RuneofPower then
			return ids.Frost_Talent.RuneofPower;
		end	
		
		if iveins and ConRO_FullButton:IsVisible() then
			return ivUSE;
		end	

		if flurry and bfBuff and wcCount <= 0 and (currentSpell == ids.Frost_Ability.Frostbolt or currentSpell == ids.Frost_Talent.Ebonbolt or _MirrorsofTorment_DEBUFF) then
			return ids.Frost_Ability.Flurry;
		end

		if forb then
			return foUSE;
		end

		if blizzard and frBuff then
			return ids.Frost_Ability.Blizzard;
		end	
		
		if rfrost and wcCount == 1 and ConRO_SingleButton:IsVisible() then
			return ids.Frost_Talent.RayofFrost;
		end	

		if (gspike or icicleCount >= 5) and tChosen[ids.Frost_Talent.GlacialSpike] and currentSpell ~= ids.Frost_Talent.GlacialSpike and (wcCount >= 1 or ConRO_AoEButton:IsVisible()) then
			return ids.Frost_Talent.GlacialSpike;
		end
		
		if ilance and (ConRO.lastSpellId == ids.Frost_Ability.Flurry or wcCount >= 1) then
			return ids.Frost_Ability.IceLance;
		end

		if cstorm then
			return ids.Frost_Talent.CometStorm;
		end

		if inova then
			return ids.Frost_Talent.IceNova;
		end

		if ilance and fofBuff then
			return ids.Frost_Ability.IceLance;
		end

		if ebolt and currentSpell ~= ids.Frost_Talent.Ebonbolt then
			return ids.Frost_Talent.Ebonbolt;
		end

		if _RadiantSpark_RDY and bfBuff and currentSpell ~= ids.Covenant_Ability.RadiantSpark then
			return ids.Covenant_Ability.RadiantSpark;
		end

		if _ShiftingPower_RDY and Close and (not tChosen[ids.Frost_Talent.RuneofPower] or (tChosen[ids.Frost_Talent.RuneofPower] and _RuneofPower_CCD >= 16) or ConRO_AoEButton:IsVisible()) then
			return ids.Covenant_Ability.ShiftingPower;
		end

		if _MirrorsofTorment_RDY and currentSpell ~= ids.Covenant_Ability.MirrorsofTorment then
			return ids.Covenant_Ability.MirrorsofTorment;
		end

		if fbolt then
			return ids.Frost_Ability.Frostbolt;
		end
	end



	
	if forb and ConRO_AoEButton:IsVisible() then
		return foUSE;
	end
	

	
	if cofc and ConRO_AoEButton:IsVisible() then
		return ids.Frost_Ability.ConeofCold;
	end	

end

function ConRO.Mage.FrostDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Abilities	
	local iceb 												= ConRO:AbilityReady(ids.Frost_Ability.IceBarrier, timeShift);
	local iblock 											= ConRO:AbilityReady(ids.Frost_Ability.IceBlock, timeShift);
	local csnap 											= ConRO:AbilityReady(ids.Frost_Ability.ColdSnap, timeShift);
	local mimage 											= ConRO:AbilityReady(ids.Frost_Ability.MirrorImage, timeShift);
	
	local ibBuff 											= ConRO:Aura(ids.Frost_Buff.IceBarrier, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');
	local incombat 											= UnitAffectingCombat('player');
	
--Rotations	
	if csnap and not iblock then
		return ids.Frost_Ability.ColdSnap;
	end
	
	if iblock and playerPh <= 25 and incombat then
		return ids.Frost_Ability.IceBlock;
	end
	
	if iceb and not ibBuff then
		return ids.Frost_Ability.IceBarrier;
	end

	if blazeb and not bbBuff then
		return ids.Fire_Ability.BlazingBarrier;
	end
	
	if mimage and incombat then
		return ids.Frost_Ability.MirrorImage;
	end
	
	return nil;
end